<!DOCTYPE html>
<html lang="en">
	<head>
		<title>Task bs150 detail of posts</title>
		<meta charset="utf-8" />
		<meta name="viewport" content="width=device-width, initial-scale=1" />
		<link
			rel="stylesheet"
			href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
		/>
		<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
		<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
	</head>

	<body onload="onPageLoad()">
		<div class="container jumbotron bg-light">
			<h3 class="text-center text-info mb-4">Chi tiết User</h3>
			<div class="row form-group">
				<label class="col-sm-3 col-form-label">id: </label>
				<div class="col-sm-9">
					<input
						type="text"
						class="form-control"
						id="inp-id"
						placeholder="..."
					/>
				</div>
			</div>
			<div class="row form-group">
				<label class="col-sm-3 col-form-label"> name: </label>
				<div class="col-sm-9">
					<input
						type="text"
						class="form-control"
						id="inp-name"
						placeholder="..."
					/>
				</div>
			</div>
			<div class="row form-group">
				<label class="col-sm-3 col-form-label"> username: </label>
				<div class="col-sm-9">
					<input
						type="text"
						class="form-control"
						id="inp-username"
						placeholder="..."
					/>
				</div>
			</div>
			<div class="row form-group">
				<label class="col-sm-3 col-form-label">email: </label>
				<div class="col-sm-9">
					<input type="text" class="form-control" id="inp-email" />
				</div>
			</div>
			<div class="row form-group">
				<label class="col-sm-3 col-form-label">address: </label>
				<div class="col-sm-9">
					<div class="row form-group">
						<label class="col-sm-3 col-form-label">street: </label>
						<div class="col-sm-9">
							<input type="text" class="form-control" id="inp-street" />
						</div>
					</div>
					<div class="row form-group">
						<label class="col-sm-3 col-form-label">suite: </label>
						<div class="col-sm-9">
							<input type="text" class="form-control" id="inp-suite" />
						</div>
					</div>
					<div class="row form-group">
						<label class="col-sm-3 col-form-label">city: </label>
						<div class="col-sm-9">
							<input type="text" class="form-control" id="inp-city" />
						</div>
					</div>
				</div>
			</div>
			<div class="row form-group">
				<label class="col-sm-3 col-form-label">zipcode: </label>
				<div class="col-sm-9">
					<input type="text" class="form-control" id="inp-zipcode" />
				</div>
			</div>
			<div class="row form-group">
				<label class="col-sm-3 col-form-label">geo: </label>
				<div class="col-sm-9">
					<div class="row form-group">
						<label class="col-sm-3 col-form-label">lat: </label>
						<div class="col-sm-9">
							<input type="text" class="form-control" id="inp-lat" />
						</div>
					</div>
					<div class="row form-group">
						<label class="col-sm-3 col-form-label">lng: </label>
						<div class="col-sm-9">
							<input type="text" class="form-control" id="inp-lng" />
						</div>
					</div>
				</div>
			</div>
			<div class="row form-group">
				<label class="col-sm-3 col-form-label">phone: </label>
				<div class="col-sm-9">
					<input type="text" class="form-control" id="inp-phone" />
				</div>
			</div>
			<div class="row form-group">
				<label class="col-sm-3 col-form-label">website: </label>
				<div class="col-sm-9">
					<input type="text" class="form-control" id="inp-website" />
				</div>
			</div>
			<div class="row form-group">
				<label class="col-sm-3 col-form-label">company: </label>
				<div class="col-sm-9">
					<div class="row form-group">
						<label class="col-sm-3 col-form-label">name: </label>
						<div class="col-sm-9">
							<input type="text" class="form-control" id="inp-company-name" />
						</div>
					</div>
					<div class="row form-group">
						<label class="col-sm-3 col-form-label">catchPhrase: </label>
						<div class="col-sm-9">
							<input type="text" class="form-control" id="inp-catchPhrase" />
						</div>
					</div>
					<div class="row form-group">
						<label class="col-sm-3 col-form-label">bs: </label>
						<div class="col-sm-9">
							<input type="text" class="form-control" id="inp-bs" />
						</div>
					</div>
				</div>
			</div>
			<div class="row">
				<div class="col-sm-12 pl-5">
					<button id="btn-update" class="btn btn-success">Update</button>
					<button id="btn-cancel" class="btn btn-success ml-5">Hủy</button>
				</div>
			</div>
		</div>
	</body>
	<script>
		/*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
		$('#btn-update').click(btnUpdateClick);
		$('#btn-cancel').click(function () {
			window.location.href = '35.10.html';
		});
		/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
		// hàm xử lý sự kiện lấy post của người dùng (4 bước xử lý)
		function onPageLoad() {
			//1.đọc dữ liệu
			var vpostIdObject = { Id: '' };
			readDatapostIdObject(vpostIdObject);
			//2.kiểm tra
			var vKetQuaKiemTra = validatepostIdObject(vpostIdObject);
			if (vKetQuaKiemTra) {
				//3. gọi server
				//base url
				const vURL_GET_POST_DETAIL =
					'https://jsonplaceholder.typicode.com/users/' + vpostIdObject.Id;
				$.ajax({
					url: vURL_GET_POST_DETAIL,
					type: 'GET',
					dataType: 'json', // added data type
					success: function (responseObject) {
						console.log(JSON.stringify(responseObject)); //response text
						//bước 4. xử lý hiện thị
						hienThiDuLieuUser(responseObject); //chính là post object
					},
					error: function (ajaxContext) {
						alert(ajaxContext.responseText);
					},
				});
			}
		}

		function btnUpdateClick() {
			var vUserObj = {
				id: '',
				name: '',
				username: '',
				email: '',
				address: {
					street: '',
					suite: '',
					city: '',
					zipcode: '',
					geo: {
						lat: '',
						lng: '',
					},
				},
				phone: '',
				website: '',
				company: {
					name: '',
					catchPhrase: '',
					bs: '',
				},
			};

			getUserObj(vUserObj);
			if (validateUserObj(vUserObj) === 1) {
				$.ajax({
					url: 'https://jsonplaceholder.typicode.com/users/' + vUserObj.id,
					type: 'PUT',
					contentType: 'application/json;charset=UTF-8',
					dataType: 'json', // added data type
					data: JSON.stringify(vUserObj),
					success: function (responseObject) {
						console.log(JSON.stringify(responseObject)); //response text
						//bước 4. xử lý hiện thị
						alert('cập nhật thành công ');
						window.location.href = '35.10.html';
					},
					error: function (ajaxContext) {
						alert(ajaxContext.responseText);
					},
				});
			}
		}
		//hiện thị dữl iệu pôst
		function hienThiDuLieuUser(paramPostObject) {
			$('#inp-id').val(paramPostObject.id);
			$('#inp-name').val(paramPostObject.name);
			$('#inp-username').val(paramPostObject.username);
			$('#inp-email').val(paramPostObject.email);
			$('#inp-street').val(paramPostObject.address.street);
			$('#inp-suite').val(paramPostObject.address.suite);
			$('#inp-city').val(paramPostObject.address.city);
			$('#inp-zipcode').val(paramPostObject.address.zipcode);
			$('#inp-lat').val(paramPostObject.address.geo.lat);
			$('#inp-lng').val(paramPostObject.address.geo.lng);
			$('#inp-phone').val(paramPostObject.phone);
			$('#inp-website').val(paramPostObject.website);
			$('#inp-company-name').val(paramPostObject.company.name);
			$('#inp-catchPhrase').val(paramPostObject.company.catchPhrase);
			$('#inp-bs').val(paramPostObject.company.bs);
		}
		// read data
		function readDatapostIdObject(parampostIdObject) {
			var vUrlString = window.location.href;
			var vURL = new URL(vUrlString);
			var vId = vURL.searchParams.get('id');

			parampostIdObject.Id = vId;
		}

		// validate data
		function validatepostIdObject(parampostIdObject) {
			if (parampostIdObject.Id === '') {
				alert('Dữ liệu cần truyền vào !');
				return false;
			}
			if (isNaN(parampostIdObject.Id)) {
				alert('Dữ liệu là số nguyên !');
				return false;
			}
			return true;
		}

		function getUserObj(paramObj) {
			paramObj.id = $('#inp-id').val().trim();
			paramObj.name = $('#inp-name').val().trim();
			paramObj.username = $('#inp-username').val().trim();
			paramObj.email = $('#inp-email').val().trim();
			paramObj.address.street = $('#inp-street').val().trim();
			paramObj.address.suite = $('#inp-suite').val().trim();
			paramObj.address.city = $('#inp-city').val().trim();
			paramObj.address.zipcode = $('#inp-zipcode').val().trim();
			paramObj.address.geo.lat = $('#inp-lat').val().trim();
			paramObj.address.geo.lng = $('#inp-lng').val().trim();
			paramObj.phone = $('#inp-phone').val().trim();
			paramObj.website = $('#inp-website').val().trim();
			paramObj.company.name = $('#inp-company-name').val().trim();
			paramObj.company.catchPhrase = $('#inp-catchPhrase').val().trim();
			paramObj.company.bs = $('#inp-bs').val().trim();
		}
		function validateUserObj(paramObj) {
			if (paramObj.id === '') {
				alert('nhập id ... ');
			} else if (paramObj.name === '') {
				alert('nhập name ... ');
			} else if (paramObj.username === '') {
				alert('nhập username ... ');
			} else if (paramObj.email === '') {
				alert('nhập email ... ');
			} else if (paramObj.address.street === '') {
				alert('nhập street ... ');
			} else if (paramObj.address.suite === '') {
				alert('nhập suite ... ');
			} else if (paramObj.address.city === '') {
				alert('nhập city ... ');
			} else if (paramObj.address.zipcode === '') {
				alert('nhập zipcode ... ');
			} else if (paramObj.address.geo.lat === '') {
				alert('nhập lat ... ');
			} else if (paramObj.address.geo.lng === '') {
				alert('nhập lng ... ');
			} else if (paramObj.phone === '') {
				alert('nhập phone ... ');
			} else if (paramObj.website === '') {
				alert('nhập website ... ');
			} else if (paramObj.company.name === '') {
				alert('nhập company name ... ');
			} else if (paramObj.company.catchPhrase === '') {
				alert('nhập catchPhrase ... ');
			} else if (paramObj.bs === '') {
				alert('nhập bs ... ');
			} else return 1;
		}
	</script>
</html>
